library(SPPr)
require(constants)
require(baptMisc)
 # clr()


## basic example for thin film stack ##

data(scanSPP) # example of measured data.frame: extangle, signal, reference,  see ?read.table
head(scanSPP)

data(AuJChristy)
test <- plot.material(material = "AuJChristy", all = FALSE, plot= F, range.lambda = c(0.5, 7), fine.n = 200)$fine.sample
with(test, epsilon[which.min(abs(lambda - 0.670))])

parameters <- list(epsilon = c(1.514^2, -14.4+1.0i,1.48^2,  1+0i),
		thickness = c(NA, 50,0,  NA), 
		lambda = 670, 
		k0 = 2*pi/632.8, 
		anglePrism = pi/3, 
		zeroShift = 0.0, 
		normalisation = 23)
		
plotModel(parameters, angle=c(-30, 0), add=F, col=2)

dataNorm <- data2norm(scanSPP,parameters)
head(dataNorm)

# plotData(dataNorm, internal=TRUE,plot=TRUE, col=1, ylim=c(0, 1))
# criticalEdge(parameters, col=grey(0.5), lty=2)

parameters$zeroShift <- -0.4

dataNorm <- data2norm(scanSPP,parameters)
plotData(dataNorm, internal=TRUE,plot=TRUE, col=1, ylim=c(0, 1))
criticalEdge(parameters, col=grey(0.5), lty=2)

layer2fit <- 1
# spp.model(parameters, angle=dataNorm$extAngle, length=100)

plotModel(parameters, angle=dataNorm$extAngle, quiet=F, add=TRUE,col=2)

p.ini <- pIni(parameters, layer2fit)

result <- optim(p.ini, objF)

yFin <- fitModel(result$par)
yErr<-abs(yFin-dataNorm$N)

lines(dataNorm$intAngle, yFin, col=3)
				
parameters <- updateParameters(result$par, layer=1)		

# fit other layers ... 
		